/*****************************************************************************

		Copyright (c) 1998 CIIP, IRDP

 Project:  INVENT
 FileName: UTIL.PRO
 Purpose: Inventaire du matriel
 Written by: L.-O. Pochon
 Comments:
******************************************************************************/

include "wxgoto.inc"


% -- tri
PREDICATES
%  quicksort(slist,slist) -(i,o)
  append(slist,slist,slist) 
  split(STRING,slist,slist,slist)
  before(STRING,STRING) % provient de l'ordre des noms
  membred (STRING,SLIST)
  
CLAUSES
  makeset([],[]) :- !.
  makeset([E|R],R1) :-
  	membred(E,R),!,
  	makeset(R,R1).
  makeset([E|R],[E|R1]) :-
  	makeset(R,R1).

  membred(S,[S|_]) :- !.
  membred(S,[_|R]) :- membred(S,R).  

  memberi(S,[S|_]).
  memberi(S,[_|R]) :- memberi(S,R).  

  quicksort([],[]).
  quicksort( [H | Tail],Sorted):-
        split(H,Tail,Before,After),
        quicksort(Before,BeforeSorted),
        quicksort(After,AfterSorted),
        append(BeforeSorted,[H|AfterSorted],Sorted).

  split(_,[],[],[]).
  split(H,[A|Tail],[A|Before],After):-
        before(A,H),!,
        split(H,Tail,Before,After).
  split(H,[A|Tail],Before,[A|After]):-
        split(H,Tail,Before,After). 
 
  append([],L,L).
  append([X|L1],L2,[X|L3]):-
          append(L1,L2,L3).

% d'abord ordre alph des noms
  before(NAME1,NAME2) :-
    	NAME1<NAME2.
% --

DATABASE - msg
  db_erreur(STRING)
  db_message(STRING)
  
CLAUSES
  error_handler(S,E) :-
	retractall(db_erreur(_)),
	format(STR,"% - Erreur de code = %",S,E),
	assertz(db_erreur(STR),msg),
	fail.

  error_new(STR) :-
  	error_cls(),
  	assertz(db_erreur(STR),msg).
  	
  error_msg(STR) :-
  	db_erreur(STR),!.

  error_cls() :-
  	retractall(db_erreur(_)).
  	
  error_free() :-
 	not(db_erreur(_)),!.

CLAUSES
  grab(S) :- openappend(tracefile,"trace.dat"),
             writedevice(tracefile),
             write(S),nl,
             closefile(tracefile).
             
PREDICATES
  assemble_sep0(CHAR,SLIST,STRING,STRING)
%  assemble_sep0(CHAR,SIDENT,STRING,STRING)
  
CLAUSES  	
  assemble_sep(C,L,STR) :- assemble_sep0(C,L,"",STR).
  
  assemble_sep0(_,[],IN,IN) :- !.
  assemble_sep0(_,[S],IN,OUT) :-
  	concat(IN,S,OUT),!.
  assemble_sep0(C,[A|R],IN,OUT) :-
  	concat(IN,A,INA),
  	str_char(SC,C),
  	concat(INA,SC,IN1),
  	assemble_sep0(C,R,IN1,OUT).
% ***
  	
  ote(S,[S|R],R) :- !.
  ote(S,[E|R],[E|R1]) :-
  	ote(S,R,R1).

PREDICATES
  max(ilist,INTEGER)

CLAUSES
  max([A],A) :- !.
  max([A,B|R],M) :- A>=B,!,max([A|R],M).
  max([_,B|R],M) :- max([B|R],M).
  
% maximum plus petit que  
  max_sm([A],PP,A) :- A<=PP,!.
  max_sm([A,B|R],PP,M) :- A>=B,A<=PP,!,max_sm([A|R],PP,M).
  max_sm([_,B|R],PP,M) :- B<=PP,!,max_sm([B|R],PP,M).
  max_sm([_,_|R],PP,M) :- max_sm(R,PP,M).